/*****************************************************************************/
/*                                                                           */
/* AresFit : aprospoly.c                                                     */
/*                                                                           */
/* Created:       2014/12/17 (JLe)                                           */
/* Last modified: 2014/12/17 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Returns value of Apros polynomial                            */
/*                                                                           */
/* Comments:                                                                 */
/*                                                                           */
/*****************************************************************************/

#include "header.h"

#define FUNCTION_NAME "AprosPoly"

/*****************************************************************************/

double AprosPoly(double *coe, double x1, double x2, double x3)
{
  double S, a, b, c, d, e, f;

  /* Read coefficients */

  a = coe[1];
  b = coe[2];
  c = coe[3];
  d = coe[4];
  e = coe[5];
  f = coe[6];

  /* Calculate value */
  
  S = coe[0] + (b*x1+a)*x1 + (d*x2+c)*x2 + (f*x3+e)*x3;

  return S;
}

/*****************************************************************************/

