/*****************************************************************************/
/*                                                                           */
/* AresFit : arespoly.c                                                      */
/*                                                                           */
/* Created:       2014/09/15 (JLe)                                           */
/* Last modified: 2014/09/15 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Returns value of ARES polynomial                             */
/*                                                                           */
/* Comments:                                                                 */
/*                                                                           */
/*****************************************************************************/

#include "header.h"

#define FUNCTION_NAME "ARESPoly"

/*****************************************************************************/

double ARESPoly(double *coe, double x1, double x2, double x3, double x4, 
	       double x5, double x6)
{
  double S, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w;

  a = coe[1];
  b = coe[2];
  c = coe[3];
  d = coe[4];
  e = coe[5];
  f = coe[6];
  g = coe[7];
  h = coe[8];
  i = coe[9];
  j = coe[10];
  k = coe[11];
  l = coe[12];
  m = coe[13];
  n = coe[14];
  o = coe[15];
  p = coe[16];
  q = coe[17];
  r = coe[18];
  s = coe[19];
  t = coe[20];
  u = coe[21];
  v = coe[22];
  w = coe[23];

  S = coe[0] + (a*x1+b)*x1 + (c*x2+d)*x2 + (e*x3+f)*x3 + g*x1*x2 + 
    (h*x3+i)*x1*x3 + j*x2*x3 + k*x4 + (l*x5+m)*x5 + (n*x6+o)*x6 + 
    (p*x5*x5*x3*x3+q*x5*x5*x3+v*x5*x3*x3+w*x5*x3) + (r*x5+s)*x5*x2 + 
    (t*x5+u)*x5*x1;

  return S;
}

/*****************************************************************************/

