/*****************************************************************************/
/*                                                                           */
/* AresFit : atof.c                                                          */
/*                                                                           */
/* Created:       2014/12/05 (JLe)                                           */
/* Last modified: 2014/12/05 (JLe)                                           */
/* Version:       1.0.0                                                       */
/*                                                                           */
/* Description: Array to double conversion with type checking                */
/*                                                                           */
/* Comments: - From Serpent 2                                                */
/*                                                                           */
/*****************************************************************************/

#include "header.h"

#define FUNCTION_NAME "AtoF:"

/*****************************************************************************/

double AtoF(char *str)
{
  long n;

  /* Loop over string */

  for (n = 0; n < (long)strlen(str); n++)
    {
      /* Check that entry is numerical */

      if (!isdigit(str[n]) && (str[n] != '.') && (str[n] != '-') && 
	  (str[n] != '+') && (str[n] != 'e') && (str[n] != 'E'))
	Die(NULL, "Invalid numerical entry '%s'", str);
    }

  /* Return number */

  return atof(str);
}

/*****************************************************************************/
