/*****************************************************************************/
/*                                                                           */
/* AresFit : atoi.c                                                          */
/*                                                                           */
/* Created:       2014/12/15 (JLe)                                           */
/* Last modified: 2014/12/15 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Array to integer conversion with type checking               */
/*                                                                           */
/* Comments: - From Serpent 2                                                */
/*                                                                           */
/*****************************************************************************/

#include "header.h"

#define FUNCTION_NAME "AtoI:"

/*****************************************************************************/

long AtoI(char *str)
{
  long n;

  /* Loop over string */

  for (n = 0; n < (long)strlen(str); n++)
    {
      /* Check that entry is numerical */

      if (!isdigit(str[n]) && (str[n] != '-'))
	Die(NULL, "Invalid integer entry '%s'", str);
    }

  /* Return number */

  return atol(str);
}

/*****************************************************************************/
