/*****************************************************************************/
/*                                                                           */
/* AresFit : checkvalue.c                                                    */
/*                                                                           */
/* Created:       2014/08/26 (JLe)                                           */
/* Last modified: 2014/08/26 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Checks that value is within allowed limits                   */
/*                                                                           */
/* Comments:                                                                 */
/*                                                                           */
/*****************************************************************************/

#include "header.h"

#define FUNCTION_NAME "CheckValue:"

/*****************************************************************************/

#ifdef DEBUG

void CheckValue(char *func, char *param, double value, double min, double max)
{
  char msg[MAX_STR];

  if ((value >= min) && (value <= max))
    return;
  else if (value > max)
    sprintf(msg, "Value %E of parameter \"%s\" above upper limit %E", value, 
	param, max);
  else if (value < min)
    sprintf(msg, "Value %E of parameter \"%s\" below lower limit %E", value, 
	param, min);
  else
    sprintf(msg, "Invalid value %E of parameter \"%s\"", value, param);

  Die(func, "%s", msg);
}

#endif

/*****************************************************************************/
