/*****************************************************************************/
/*                                                                           */
/* AresFit : die.c                                                           */
/*                                                                           */
/* Created:       2014/08/24 (JLe)                                           */
/* Last modified: 2014/08/24 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Terminates run in fatal error                                */
/*                                                                           */
/* Comments:                                                                 */
/*                                                                           */
/*****************************************************************************/

#include "header.h"

#define FUNCTION_NAME "Die:"

/*****************************************************************************/

void Die(char *func, ...)
{
  va_list argp;
  va_start (argp, func);

  /* Print error message */
  
  if (func != NULL)
    fprintf(err, "\nFatal error in function %s\n\n", func);
  else
    fprintf(err, "\nFatal error:\n\n");

  vfprintf(err, va_arg(argp, char *), argp);
  fprintf(err, "\n\n");

  /* Exit */

  exit(-1);
}

/*****************************************************************************/
