/*****************************************************************************/
/*                                                                           */
/* AresFit : firstitem.c                                                     */
/*                                                                           */
/* Created:       2015/02/23 (JLe)                                           */
/* Last modified: 2015/02/23 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Returns pointer to first item in list or -1 if list doesn't  */
/*              exist.                                                       */
/*                                                                           */
/* Comments: - From Serpent 2                                                */
/*                                                                           */
/*****************************************************************************/

#include "header.h"
#include "locations.h"

#define FUNCTION_NAME "FirstItem:"

/*****************************************************************************/

long FirstItem(long ptr)
{
  long loc0;

  /* Check pointer */

  if (ptr < VALID_PTR)
    return -1;

  /* Get pointer to common data */

  loc0 = (long)RDB[ptr + LIST_PTR_COMMON];

  /* Get pointer to first */

  ptr = (long)RDB[loc0 + LIST_COMMON_PTR_FIRST];

  /*  Check pointer */

  CheckPointer(FUNCTION_NAME, "(ptr)", DATA_ARRAY, ptr); 

  /* Return pointer to first item */

  return ptr;
}

/*****************************************************************************/
