/*****************************************************************************/
/*                                                                           */
/* AresFit : getxs.c                                                         */
/*                                                                           */
/* Created:       2014/08/31 (JLe)                                           */
/* Last modified: 2014/09/21 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Returns cross section for a given state                      */ 
/*                                                                           */
/* Comments:                                                                 */
/*                                                                           */
/*****************************************************************************/

#include "header.h"
#include "locations.h"

#define FUNCTION_NAME "GetXS:"

/*****************************************************************************/

double GetXS(long lib, long para, double VHI, double BHI, double BOR, 
	     double CR, double TFU, double VOI, double TMO, double EXP)
{
  long his, xsp, code;
  double val, tmp;

  /* Get code */

  code = (long)RDB[DATA_CODE];

  /* Loop over histories */

  his = (long)RDB[lib + LIB_PTR_HIS];
  while (his > VALID_PTR)
    {
      /* Loop over data */

      xsp = (long)RDB[his + HIS_PTR_XS];
      while (xsp > VALID_PTR)
	{
	  /* Input-parametri on lämpötila nyt APROS-moodissa */

	  if (code == CODE_ARES)
	    tmp = RDB[xsp + XS_TMO];
	  else
	    tmp = RDB[xsp + XS_RHO];
 
	  /* Compare */

	  if (RDB[xsp + XS_EXP] == EXP)
	    if (RDB[xsp + XS_BHI] == BHI)
	      if (RDB[xsp + XS_VHI] == VHI)
		if (RDB[xsp + XS_BOR] == BOR)
		  if (RDB[xsp + XS_CR ] == CR) 
		    if (RDB[xsp + XS_TFU] == TFU)
		      if (RDB[xsp + XS_VOI] == VOI)
			if (tmp == TMO)
			  {
			    /* Add to used counter */
			    
			    WDB[xsp + XS_USED] = RDB[xsp + XS_USED] + 1.0;

			    /* Get value */

			    val = RDB[xsp + para];

			    /* Check if more than 1 items */

			    /* Jos tän laittaa niin kaikkea ei testata */

#ifdef mmmm
			    if (ListSize(his) > 1)
			      {
				/* Remove item from list */
			    
				RemoveItem(xsp);
				
				/* Put back to list */
				
				AddItem(his + HIS_PTR_XS, xsp);
			      }
#endif
			    /* Return value */

			    return val; 
			  }
	  /* Next */
	  
	  xsp = NextItem(xsp);
	}
      
      /* Next history */

      his = NextItem(his);
    }

  /* Not found */
  
  return 0.0;
}

/*****************************************************************************/

