/*****************************************************************************/
/*                                                                           */
/* AresFit : nextitem.c                                                      */
/*                                                                           */
/* Created:       2014/08/25 (JLe)                                           */
/* Last modified: 2014/08/25 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Returns pointer to next item in list.                        */
/*                                                                           */
/* Comments:                                                                 */
/*                                                                           */
/*****************************************************************************/

#include "header.h"
#include "locations.h"

#define FUNCTION_NAME "NextItem:"

/*****************************************************************************/

#ifdef DEBUG

long NextItem(long ptr)
{
  long next;

  /* Check pointer */

  CheckPointer(FUNCTION_NAME, "(ptr)", DATA_ARRAY, ptr);

  /* Get pointer to next */
  
  next = (long)RDB[ptr + LIST_PTR_NEXT];

  /* Check self */

  if (next == ptr)
    Die(FUNCTION_NAME, "Pointer to self");

  /* Check null */

  if (next == NULLPTR)
    return next;

  /* Check pointer */

  CheckPointer(FUNCTION_NAME, "(next)", DATA_ARRAY, next);

  /* Return pointer to next item */

  return next;
}

#endif

/*****************************************************************************/
