/*****************************************************************************/
/*                                                                           */
/* AresFit : openfile.c                                                      */
/*                                                                           */
/* Created:       2014/08/24 (JLe)                                           */
/* Last modified: 2014/08/24 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Opens data file for reading                                  */
/*                                                                           */
/* Comments:                                                                 */
/*                                                                           */
/*****************************************************************************/

#include "header.h"

#define FUNCTION_NAME "OpenFile:"

/*****************************************************************************/

FILE *OpenFile(char *fname, char *mode)
{
  FILE *fp;

  /* Open file */

  if ((fp = fopen(fname, mode)) != NULL)
    {
      /* Return file pointer */

      return fp;
    }
  else if (!strcmp(mode, "r"))
    Die(NULL, "Unable to open file '%s' for reading", fname);
  else
    Die(NULL, "Unable to open file '%s' for writing", fname);

  /* Avoid compiler warning */

  return NULL;
}

/*****************************************************************************/
