/*****************************************************************************/
/*                                                                           */
/* AresFit : readf.c                                                         */
/*                                                                           */
/* Created:       2014/12/15 (JLe)                                           */
/* Last modified: 2014/12/15 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: Reads integer from file with error checking                  */
/*                                                                           */
/* Comments: - From Serpent 2                                                */
/*                                                                           */
/*****************************************************************************/

#include "header.h"

#define FUNCTION_NAME "ReadI:"

/*****************************************************************************/

long ReadI(FILE *fp)
{
  char str[MAX_STR];
  long n;

  /* Check file pointer */

  if (fp == NULL)
    Die(FUNCTION_NAME, "Null file pointer");

  /* Read next value */

  if (fscanf(fp, "%s", str) == EOF)
    Die(FUNCTION_NAME, "fscanf error");

  /* Loop over string */

  for (n = 0; n < (long)strlen(str); n++)
    {
      /* Check that entry is numerical */

      if (!isdigit(str[n]) && (str[n] != '-'))
	Die(NULL, "Invalid integer entry '%s'", str);
    }

  /* Return number */

  return atol(str);
}

/*****************************************************************************/
