/*****************************************************************************/
/*                                                                           */
/* AresFit : seekliststr.c                                                   */
/*                                                                           */
/* Created:       2015/02/23 (JLe)                                           */
/* Last modified: 2015/02/23 (JLe)                                           */
/* Version:       1.0.0                                                      */
/*                                                                           */
/* Description: - Seeks item with matching string                            */
/*                                                                           */
/* Comments: - From Serpent 2                                                */
/*                                                                           */
/*****************************************************************************/

#include "header.h"
#include "locations.h"

#define FUNCTION_NAME "SeekListStr:"

/*****************************************************************************/

long SeekListStr(long ptr, long param, char *str)
{
  /* Check pointer */

  if (ptr < VALID_PTR)
    return -1;

  CheckPointer(FUNCTION_NAME, "(ptr)", DATA_ARRAY, ptr);

  /* Move to beginning */

  ptr = FirstItem(ptr);

  /* Loop over list */
  
  while (ptr > VALID_PTR)
    {
      /* Check */

      if ((long)RDB[ptr + param] < VALID_PTR)
	Die(FUNCTION_NAME, "Pointer error");

      /* Compare */

      if (!strcmp(GetText(ptr + param), str))
	return ptr;
	      
      /* Next */
      
      ptr = NextItem(ptr);
    }

  /* Not found, return null */

  return -1;
}

/*****************************************************************************/
